git-applymbox.shon commit GIT 0.99.9e (72e5890)
   1#!/bin/sh
   2##
   3## "dotest" is my stupid name for my patch-application script, which
   4## I never got around to renaming after I tested it. We're now on the
   5## second generation of scripts, still called "dotest".
   6##
   7## Update: Ryan Anderson finally shamed me into naming this "applymbox".
   8##
   9## You give it a mbox-format collection of emails, and it will try to
  10## apply them to the kernel using "applypatch"
  11##
  12## The patch application may fail in the middle.  In which case:
  13## (1) look at .dotest/patch and fix it up to apply
  14## (2) re-run applymbox with -c .dotest/msg-number for the current one.
  15## Pay a special attention to the commit log message if you do this and
  16## use a Signoff_file, because applypatch wants to append the sign-off
  17## message to msg-clean every time it is run.
  18##
  19## git-am is supposed to be the newer and better tool for this job.
  20
  21. git-sh-setup || die "Not a git archive"
  22
  23usage () {
  24    echo >&2 "applymbox [-u] [-k] [-q] [-m] (-c .dotest/<num> | mbox) [signoff]"
  25    exit 1
  26}
  27
  28keep_subject= query_apply= continue= utf8= resume=t
  29while case "$#" in 0) break ;; esac
  30do
  31        case "$1" in
  32        -u)     utf8=-u ;;
  33        -k)     keep_subject=-k ;;
  34        -q)     query_apply=t ;;
  35        -c)     continue="$2"; resume=f; shift ;;
  36        -m)     fallback_3way=t ;;
  37        -*)     usage ;;
  38        *)      break ;;
  39        esac
  40        shift
  41done
  42
  43case "$continue" in
  44'')
  45        rm -rf .dotest
  46        mkdir .dotest
  47        num_msgs=$(git-mailsplit "$1" .dotest) || exit 1
  48        echo "$num_msgs patch(es) to process."
  49        shift
  50esac
  51
  52files=$(git-diff-index --cached --name-only HEAD) || exit
  53if [ "$files" ]; then
  54   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
  55   exit 1
  56fi
  57
  58case "$query_apply" in
  59t)      touch .dotest/.query_apply
  60esac
  61case "$fall_back_3way" in
  62t)      : >.dotest/.3way
  63esac
  64case "$keep_subject" in
  65-k)     : >.dotest/.keep_subject
  66esac
  67
  68signoff="$1"
  69set x .dotest/0*
  70shift
  71while case "$#" in 0) break;; esac
  72do
  73    i="$1" 
  74    case "$resume,$continue" in
  75    f,$i)       resume=t;;
  76    f,*)        shift
  77                continue;;
  78    *)
  79            git-mailinfo $keep_subject $utf8 \
  80                .dotest/msg .dotest/patch <$i >.dotest/info || exit 1
  81            git-stripspace < .dotest/msg > .dotest/msg-clean
  82            ;;
  83    esac
  84    while :; # for fixing up and retry
  85    do
  86        git-applypatch .dotest/msg-clean .dotest/patch .dotest/info "$signoff"
  87        case "$?" in
  88        0)
  89                # Remove the cleanly applied one to reduce clutter.
  90                rm -f .dotest/$i
  91                ;;
  92        2)
  93                # 2 is a special exit code from applypatch to indicate that
  94                # the patch wasn't applied, but continue anyway 
  95                ;;
  96        *)
  97                ret=$?
  98                if test -f .dotest/.query_apply
  99                then
 100                        echo >&2 "* Patch failed."
 101                        echo >&2 "* You could fix it up in your editor and"
 102                        echo >&2 "  retry.  If you want to do so, say yes here"
 103                        echo >&2 "  AFTER fixing .dotest/patch up."
 104                        echo >&2 -n "Retry [y/N]? "
 105                        read yesno
 106                        case "$yesno" in
 107                        [Yy]*)
 108                                continue ;;
 109                        esac
 110                fi
 111                exit $ret
 112        esac
 113        break
 114    done
 115    shift
 116done
 117# return to pristine
 118rm -fr .dotest